{ Copyright(C) ɹ 2001-2002}
{ Programmed by Ma Bingyao }
{ Aug 19, 2002 09:50 }
Unit xdos;

{****************************} interface {*********************************}

const
  SEEK_SET=0;
  SEEK_CUR=1;
  SEEK_END=2;
  READ_ONLY=0;
  WRITE_ONLY=1;
  READ_WRITE=2;
  OPEN_FAIL=0;
  OPEN_CREATE=4;

type
  PDirTreeNode=^DirTreeNode;
  DirTreeNode=Packed Record
    Child:PDirTreeNode;
    Brother:PDirTreeNode;
    Name:string;
    Attr:word;
    CreationTimeMilliSecond:byte;
    CreationTime:longint;
    LastAccessTime:longint;
    LastWriteTime:longint;
    StartUnitNum:word;
    Size:longint;
  end;

function IOisOK:boolean;
function GetWinVer:byte;
procedure ResetDrive(Drive:word);
procedure SetDefaultDrive(Drive:char);
function GetDefaultDrive:char;
procedure CloseFile(FileHandle:word);
procedure ReadFile(FileHandle:word; var BufferLen:word; Var Buffer);
procedure WriteFile(FileHandle:word; var BufferLen:word; Var Buffer);
procedure LseekFile(FileHandle:word; var Position:longint; Mode:byte);
procedure GetFileLastWriteTime(FileHandle:word; var FileTime:longint);
procedure SetFileLastWriteTime(FileHandle:word; FileTime:longint);
procedure GetFileLastAccessTime(FileHandle:word; var FileTime:longint);
procedure SetFileLastAccessTime(FileHandle:word; FileTime:longint);
procedure GetFileCreationTime(FileHandle:word; var FileTime:longint; var MilliSecond:byte);
procedure SetFileCreationTime(FileHandle:word; FileTime:longint; MilliSecond:byte);
procedure MD(DirName:string);
procedure RD(DirName:string);
procedure CD(DirName:string);
procedure DeleteFile(FileName:string);
procedure GetFileAttr(FileName:string; var FileAttr:word);
procedure SetFileAttr(FileName:string; FileAttr:word);
procedure CWD(Drive:byte; var DirName:string);
procedure Ren(OldName:string; NewName:string);
procedure OpenFile(FileName:string; var FileHandle:word; RWMode:byte; Action:byte);
procedure CreateFile(FileName:string; var FileHandle:word; RWMode:byte; FileAttr:byte);
procedure FindClose;
procedure FindFirst(Path:string; Attr:word; DirNode:PDirTreeNode);
procedure FindNext(DirNode:PDirTreeNode);
procedure GetTrueName(Path:string; var TrueName:string);
procedure GetShortName(LongName:string; var ShortName:string);
procedure GetLongName(ShortName:string; var LongName:string);
procedure CreateTempFile(Path:string; var TempFileName:string; var FileHandle:word; FileAttr:byte);
function GetTempDir:string;
procedure FSplit(Path:string; var Drive:string; var Dir:string; var FileName:string; var Ext:string);

{*************************} implementation {*******************************}
uses dos, go32, xstr;

var
  IOStatus:boolean;

function IOisOK:boolean;
begin
  IOisOK:=IOStatus;
end;

function GetWinVer:byte;
var
  regs:registers;
begin
    regs.ax:=$1600;
    intr($2F, regs);
    GetWinVer:=regs.al;
end;

procedure ResetDrive(Drive:word);
var
  regs:registers;
begin
  if LFNSupport then begin
    regs.ax:=$714D;
    regs.cx:=1;
    regs.dx:=Drive;
  end
  else regs.ah:=$4D;
  msdos(regs);
  IOstatus:=true;
end;

procedure SetDefaultDrive(Drive:char);
var
  regs:registers;
begin
  regs.ah:=$0E;
  regs.dl:=ord(Upcase(Drive))-ord('A');
  msdos(regs);
end;

function GetDefaultDrive:char;
var
  regs:registers;
begin
  regs.ah:=$19;
  msdos(regs);
  GetDefaultDrive:=chr(regs.al+ord('A'));
end;

procedure CloseFile(FileHandle:word);
var
  regs:registers;
begin
  regs.ah:=$3E;
  regs.bx:=FileHandle;
  msdos(regs);
  if (regs.flags and fcarry)=0 then IOstatus:=true
  else IOstatus:=false;
end;

procedure ReadFile(FileHandle:word; Var BufferLen:word; Var Buffer);
var
  regs:registers;
begin
  regs.ah:=$3F;
  regs.bx:=FileHandle;
  regs.cx:=BufferLen;
  regs.ds:=tb_segment;
  regs.edx:=tb_offset;
  msdos(regs);
  if (regs.flags and fcarry)=0 then begin
    IOstatus:=true;
    BufferLen:=regs.ax;
    copyfromdos(Buffer, BufferLen);
  end
  else IOstatus:=false;
end;

procedure WriteFile(FileHandle:word; Var BufferLen:word; Var Buffer);
var
  regs:registers;
begin
  regs.ah:=$40;
  regs.bx:=FileHandle;
  regs.cx:=BufferLen;
  copytodos(Buffer, BufferLen);
  regs.ds:=tb_segment;
  regs.edx:=tb_offset;
  msdos(regs);
  if (regs.flags and fcarry)=0 then begin
    IOstatus:=true;
    BufferLen:=regs.ax;
  end
  else IOstatus:=false;
end;

procedure LseekFile(FileHandle:word; Var Position:longint; Mode:byte);
var
  regs:registers;
begin
  regs.ah:=$42;
  regs.al:=Mode;
  regs.bx:=FileHandle;
  regs.dx:=(Position and $FFFF);
  regs.cx:=(Position shr 16);
  msdos(regs);
  if (regs.flags and fcarry)=0 then begin
    IOstatus:=true;
    Position:=((longint(regs.dx) shl 16) or longint(regs.ax));
  end
  else IOstatus:=false;
end;

procedure GetFileLastWriteTime(FileHandle:word; var FileTime:longint);
var
  regs:registers;
begin
  regs.ax:=$5700;
  regs.bx:=FileHandle;
  msdos(regs);
  if (regs.flags and fcarry)=0 then begin
    IOstatus:=true;
    FileTime:=((longint(regs.dx) shl 16) or longint(regs.cx));
  end
  else IOstatus:=false;
end;

procedure SetFileLastWriteTime(FileHandle:word; FileTime:longint);
var
  regs:registers;
begin
  regs.ax:=$5701;
  regs.bx:=FileHandle;
  regs.cx:=(FileTime and $FFFF);
  regs.dx:=(FileTime shr 16);
  msdos(regs);
  if (regs.flags and fcarry)=0 then IOstatus:=true
  else IOstatus:=false;
end;

procedure GetFileLastAccessTime(FileHandle:word; var FileTime:longint);
var
  regs:registers;
begin
  if LFNSupport then begin
    regs.ax:=$5704;
    regs.bx:=FileHandle;
    msdos(regs);
    if (regs.flags and fcarry)=0 then begin
      IOstatus:=true;
      FileTime:=((longint(regs.dx) shl 16) or longint(regs.cx));
    end
    else IOstatus:=false;
  end
  else IOstatus:=false;
end;

procedure SetFileLastAccessTime(FileHandle:word; FileTime:longint);
var
  regs:registers;
begin
  if LFNSupport then begin
    regs.ax:=5705;
    regs.bx:=FileHandle;
    regs.cx:=0;
    regs.dx:=(FileTime shr 16);
    msdos(regs);
    if (regs.flags and fcarry)=0 then IOstatus:=true
    else IOstatus:=false;
  end
  else IOstatus:=false;
end;

procedure GetFileCreationTime(FileHandle:word; var FileTime:longint; var MilliSecond:byte);
var
  regs:registers;
begin
  if LFNSupport then begin
    regs.ax:=$5706;
    regs.bx:=FileHandle;
    msdos(regs);
    if (regs.flags and fcarry)=0 then begin
      IOstatus:=true;
      FileTime:=((longint(regs.dx) shl 16) or longint(regs.cx));
      MilliSecond:=byte(regs.si);
    end
    else IOstatus:=false;
  end
  else IOstatus:=false;
end;

procedure SetFileCreationTime(FileHandle:word; FileTime:longint; MilliSecond:byte);
var
  regs:registers;
begin
  if LFNSupport then begin
    regs.ax:=$5707;
    regs.bx:=FileHandle;
    regs.cx:=(FileTime and $FFFF);
    regs.dx:=(FileTime shr 16);
    regs.si:=MilliSecond;
    msdos(regs);
    if (regs.flags and fcarry)=0 then IOstatus:=true
    else IOstatus:=false;
  end
  else IOstatus:=false;
end;

procedure MD(DirName:string);
var
  regs:registers;
  namelen:byte;
begin
  namelen:=Length(DirName) + 1;
  Pas2Cstr(DirName);
  copytodos(DirName, namelen);
  if LFNSupport then begin
    regs.ax:=$7139;
    regs.flags:=fcarry;
  end
  else regs.ah:=$39;
  regs.ds:=tb_segment;
  regs.edx:=tb_offset;
  msdos(regs);
  if (regs.flags and fcarry)=0 then IOstatus:=true
  else IOstatus:=false;
end;

procedure RD(DirName:string);
var
  regs:registers;
  namelen:byte;
begin
  namelen:=Length(DirName) + 1;
  Pas2Cstr(DirName);
  copytodos(DirName, namelen);
  if LFNSupport then begin
    regs.ax:=$713A;
    regs.flags:=fcarry;
  end
  else regs.ah:=$3A;
  regs.ds:=tb_segment;
  regs.edx:=tb_offset;
  msdos(regs);
  if (regs.flags and fcarry)=0 then IOstatus:=true
  else IOstatus:=false;
end;

procedure CD(DirName:string);
var
  regs:registers;
  namelen:byte;
begin
  namelen:=Length(DirName) + 1;
  Pas2Cstr(DirName);
  copytodos(DirName, namelen);
  if LFNSupport then begin
    regs.ax:=$713B;
    regs.flags:=fcarry;
  end
  else regs.ah:=$3B;
  regs.ds:=tb_segment;
  regs.edx:=tb_offset;
  msdos(regs);
  if (regs.flags and fcarry)=0 then IOstatus:=true
  else IOstatus:=false;
end;

procedure DeleteFile(FileName:string);
var
  regs:registers;
  namelen:byte;
begin
  namelen:=Length(FileName) + 1;
  Pas2Cstr(FileName);
  copytodos(FileName, namelen);
  if LFNSupport then begin
    regs.ax:=$7141;
    regs.si:=0;
    regs.ch:=anyfile;
    regs.flags:=fcarry;
  end
  else regs.ah:=$41;
  regs.cl:=anyfile;
  regs.ds:=tb_segment;
  regs.edx:=tb_offset;
  msdos(regs);
  if (regs.flags and fcarry)=0 then IOstatus:=true
  else IOstatus:=false;
end;

procedure GetFileAttr(FileName:string; var FileAttr:word);
var
  regs:registers;
  namelen:byte;
begin
  namelen:=Length(FileName) + 1;
  Pas2Cstr(FileName);
  copytodos(FileName, namelen);
  if LFNSupport then begin
    regs.ax:=$7143;
    regs.bl:=0;
    regs.flags:=fcarry;
  end
  else regs.ax:=$4300;
  regs.ds:=tb_segment;
  regs.edx:=tb_offset;
  msdos(regs);
  if (regs.flags and fcarry)=0 then begin
    IOstatus:=true;
    FileAttr:=regs.cx;
  end
  else IOstatus:=false;
end;

procedure SetFileAttr(FileName:string; FileAttr:word);
var
  regs:registers;
  namelen:byte;
begin
  namelen:=Length(FileName) + 1;
  Pas2Cstr(FileName);
  copytodos(FileName, namelen);
  if LFNSupport then begin
    regs.ax:=$7143;
    regs.bl:=1;
    regs.flags:=fcarry;
  end
  else regs.ax:=$4301;
  regs.cx:=FileAttr;
  regs.ds:=tb_segment;
  regs.edx:=tb_offset;
  msdos(regs);
  if (regs.flags and fcarry)=0 then IOstatus:=true
  else IOstatus:=false;
end;

procedure CWD(Drive:byte; var DirName:string);
var
  regs:registers;
begin
  if LFNSupport then regs.ax:=$7147
  else regs.ah:=$47;
  regs.dl:=Drive;
  regs.ds:=tb_segment;
  regs.esi:=tb_offset;
  msdos(regs);
  if (regs.flags and fcarry)=0 then begin
    IOstatus:=true;
    copyfromdos(DirName, 256);
    C2Passtr(DirName);
  end
  else IOstatus:=false;
end;

procedure Ren(OldName:string; NewName:string);
var
  regs:registers;
  OldNameLen, NewNameLen:byte;
begin
  OldNameLen:=length(OldName)+1;
  Pas2Cstr(OldName);
  copytodos(OldName, OldNameLen);
  NewNameLen:=length(NewName)+1;
  Pas2Cstr(NewName);
  dosmemput(tb_segment, tb_offset+OldNameLen+1, NewName, NewNameLen);
  if LFNSupport then begin
    regs.ax:=$7156;
    regs.flags:=fcarry;
  end
  else begin
    regs.ah:=$56;
    regs.cl:=anyfile;
  end;
  regs.ds:=tb_segment;
  regs.edx:=tb_offset;
  regs.es:=tb_segment;
  regs.edi:=tb_offset+OldNameLen+1;
  msdos(regs);
  if (regs.flags and fcarry)=0 then IOstatus:=true
  else IOstatus:=false;
end;

procedure OpenFile(FileName:string; var FileHandle:word; RWMode:byte; Action:byte);
var
  regs:registers;
  namelen:byte;
begin
  namelen:=Length(FileName) + 1;
  Pas2Cstr(FileName);
  copytodos(FileName, namelen);
  if LFNSupport then regs.ax:=$716C
  else regs.ax:=$6C00;
  regs.bx:=$2040 or RWMode;
  regs.cx:=archive;
  regs.dx:=$0001 or Action;
  regs.ds:=tb_segment;
  regs.esi:=tb_offset;
  msdos(regs);
  if (regs.flags and fcarry)=0 then begin
    IOstatus:=true;
    FileHandle:=regs.ax;
  end
  else IOstatus:=false;
end;

procedure CreateFile(FileName:string; var FileHandle:word; RWMode:byte; FileAttr:byte);
var
  regs:registers;
  namelen:byte;
begin
  namelen:=Length(FileName) + 1;
  Pas2Cstr(FileName);
  copytodos(FileName, namelen);
  if LFNSupport then regs.ax:=$716C
  else regs.ax:=$6C00;
  regs.bx:=$2040 or RWMode;
  regs.cx:=word(FileAttr);
  regs.dx:=$0012;
  regs.ds:=tb_segment;
  regs.esi:=tb_offset;
  msdos(regs);
  if (regs.flags and fcarry)=0 then begin
    IOstatus:=true;
    FileHandle:=regs.ax;
  end
  else IOstatus:=false;
end;

const
  LFN_MAX_PATH=259;

type

  DosSearchRec = packed record
    Fill : array [1..21] of byte;
    Attr : byte;
    time : longint;
    size : longint;
    name : string[12];
  end;
  Win32FileTimeRec=packed record
    LowDateTime:longint;
    HighDateTime:longint;
  end;
  Win32SearchRec=packed record
    Attr:longint;
    CreationTime:Win32FileTimeRec;
    LastAccessTime:Win32FileTimeRec;
    LastWriteTime:Win32FileTimeRec;
    HighSize:longint;
    LowSize:longint;
    Reserved0:longint;
    Reserved1:longint;
    FullName:array [0..LFN_MAX_PATH] of char;
    ShortName:array [0..13] of char;
  end;
  PSearchNode=^SearchNode;
  SearchNode=packed record
    Prev:PsearchNode;
    Win32FindHandle:word;
  case integer of
    0:(Win32FindData:Win32SearchRec);
    1:(DosFindData:DosSearchRec);
  end;

const
  CurSearch:PSearchNode=NIL;
    
procedure SetDTAaddr(DTAseg, DTAofs:word);
var
  regs:registers;
begin
  regs.ah:=$1A;
  regs.ds:=DTAseg;
  regs.dx:=DTAofs;
  msdos(regs);
end;

procedure GetDTAaddr(var DTAseg, DTAofs:word);
var
  regs:registers;
begin
  regs.ah:=$2F;
  msdos(regs);
  DTAseg := regs.es;
  DTAofs := regs.bx;
end;

procedure FindClose;
var
  regs:registers;
  tmpSearch:PSearchNode;
begin
  if CurSearch<>NIL then begin
    if LFNSupport then begin
      regs.ax:=$71A1;
      regs.bx:=CurSearch^.Win32FindHandle;
      regs.flags:=fcarry;
      msdos(regs);
      if (regs.flags and fcarry)=0 then begin
        IOstatus:=true;
        CurSearch^.Win32FindHandle:=0;
      end
      else IOstatus:=false;
    end;
    tmpSearch:=CurSearch^.Prev;
    dispose(CurSearch);
    CurSearch:=tmpSearch;
  end
  else IOstatus:=true;
end;

procedure FindFirst(Path:string; Attr:word; DirNode:PDirTreeNode);
var
  regs:registers;
  OldDTAseg, OldDTAofs:word;
  i:byte;
  tmpSearch:PSearchNode;
  pathlen:longint;
begin
  tmpSearch:=CurSearch;
  New(CurSearch);
  CurSearch^.Prev:=tmpSearch;
  pathlen:=length(Path) + 1;
  Pas2Cstr(Path);
  dosmemput(tb_segment, tb_offset+sizeof(SearchNode), Path, pathlen);
  regs.ds:=tb_segment;
  regs.edx:=tb_offset+sizeof(SearchNode);
  regs.cx:=Attr;
  if LFNSupport then begin
    regs.ax:=$714E;
    regs.si:=1;
    copytodos(CurSearch^.Win32FindData, sizeof(Win32SearchRec));
    regs.es:=tb_segment;
    regs.edi:=tb_offset;
    msdos(regs);
    copyfromdos(CurSearch^.Win32FindData, sizeof(Win32SearchRec));
    if (regs.flags and fcarry)=0 then begin
      IOstatus:=true;
      CurSearch^.Win32FindHandle:=regs.ax;
      i:=0;
      while (CurSearch^.Win32FindData.FullName[i]>#0) and (i<255) do begin
        DirNode^.Name[i+1]:=CurSearch^.Win32FindData.FullName[i];
        inc(i);
      end;
      DirNode^.Name[0]:=char(i);
      DirNode^.Attr:=word(CurSearch^.Win32FindData.Attr and $7F);
      DirNode^.CreationTime:=CurSearch^.Win32FindData.CreationTime.LowDateTime;
      DirNode^.CreationTimeMilliSecond:=Byte(CurSearch^.Win32FindData.CreationTime.HighDateTime and $FF);
      DirNode^.LastAccessTime:=CurSearch^.Win32FindData.LastAccessTime.LowDateTime;
      DirNode^.LastWriteTime:=CurSearch^.Win32FindData.LastWriteTime.LowDateTime;
      DirNode^.Size:=CurSearch^.Win32FindData.LowSize;
    end
    else begin
      IOstatus:=false;
      CurSearch^.Win32FindHandle:=0;
    end;
  end
  else begin
    GetDTAaddr(OldDTAseg, OldDTAofs);
    copytodos(CurSearch^.DosFindData, sizeof(DosSearchRec));
    SetDTAaddr(tb_segment, tb_offset);
    regs.ax:=$4E00;
    msdos(regs);
    copyfromdos(CurSearch^.DosFindData, sizeof(DosSearchRec));
    SetDTAaddr(OldDTAseg, OldDTAofs);
    if (regs.flags and fcarry)=0 then begin
      IOstatus:=true;
      DirNode^.Name:=CurSearch^.DosFindData.Name;
      C2Passtr(DirNode^.Name);
      DirNode^.Attr:=word(CurSearch^.DosFindData.Attr);
      DirNode^.CreationTime:=0;
      DirNode^.CreationTimeMilliSecond:=0;
      DirNode^.LastAccessTime:=0;
      DirNode^.LastWriteTime:=CurSearch^.DosFindData.Time;
      DirNode^.Size:=CurSearch^.DosFindData.Size;
    end
    else IOstatus:=false;
  end;
end;

procedure FindNext(DirNode:PDirTreeNode);
var
  regs:registers;
  OldDTAseg, OldDTAofs:word;
  i:byte;
begin
  if LFNSupport then begin
    regs.ax:=$714F;
    regs.bx:=CurSearch^.Win32FindHandle;
    regs.si:=1;
    copytodos(CurSearch^.Win32FindData, sizeof(Win32SearchRec));
    regs.es:=tb_segment;
    regs.edi:=tb_offset;
    msdos(regs);
    copyfromdos(CurSearch^.Win32FindData, sizeof(Win32SearchRec));
    if (regs.flags and fcarry)=0 then begin
      IOstatus:=true;
      i:=0;
      while (CurSearch^.Win32FindData.FullName[i]>#0) and (i<255) do begin
        DirNode^.Name[i+1]:=CurSearch^.Win32FindData.FullName[i];
        inc(i);
      end;
      DirNode^.Name[0]:=char(i);
      DirNode^.Attr:=word(CurSearch^.Win32FindData.Attr and $7F);
      DirNode^.CreationTime:=CurSearch^.Win32FindData.CreationTime.LowDateTime;
      DirNode^.CreationTimeMilliSecond:=Byte(CurSearch^.Win32FindData.CreationTime.HighDateTime and $FF);
      DirNode^.LastAccessTime:=CurSearch^.Win32FindData.LastAccessTime.LowDateTime;
      DirNode^.LastWriteTime:=CurSearch^.Win32FindData.LastWriteTime.LowDateTime;
      DirNode^.Size:=CurSearch^.Win32FindData.LowSize;
    end
    else IOstatus:=false;
  end
  else begin
    GetDTAaddr(OldDTAseg, OldDTAofs);
    copytodos(CurSearch^.DosFindData, sizeof(DosSearchRec));
    SetDTAaddr(tb_segment, tb_offset);
    regs.ax:=$4F00;
    msdos(regs);
    copyfromdos(CurSearch^.DosFindData, sizeof(DosSearchRec));
    SetDTAaddr(OldDTAseg, OldDTAofs);
    if (regs.flags and fcarry)=0 then begin
      IOstatus:=true;
      DirNode^.Name:=CurSearch^.DosFindData.Name;
      C2Passtr(DirNode^.Name);
      DirNode^.Attr:=word(CurSearch^.DosFindData.Attr);
      DirNode^.CreationTime:=0;
      DirNode^.CreationTimeMilliSecond:=0;
      DirNode^.LastAccessTime:=0;
      DirNode^.LastWriteTime:=CurSearch^.DosFindData.Time;
      DirNode^.Size:=CurSearch^.DosFindData.Size;
    end
    else IOstatus:=false;
  end;
end;

procedure GetTrueName(Path:string; var TrueName:string);
var
  regs:registers;
  Buffer:array [0..LFN_MAX_PATH] of char;
  i:byte;
  PathLen:longint;
begin
  TrueName:=Path;
  PathLen:=length(Path)+1;
  Pas2Cstr(Path);
  copytodos(Path, PathLen);
  regs.ds:=tb_segment;
  regs.esi:=tb_offset;
  regs.es:=tb_segment;
  regs.edi:=tb_offset;
  if LFNSupport then begin
    regs.ax:=$7160;
    regs.cx:=0;
    regs.flags:=fcarry;
  end
  else regs.ah:=$60;
  msdos(regs);
  if (regs.flags and fcarry)=0 then begin
    copyfromdos(Buffer, LFN_MAX_PATH+1);
    IOstatus:=true;
    i:=0;
    while (Buffer[i]>#0) and (i<255) do begin
      TrueName[i+1]:=Buffer[i];
      inc(i);
    end;
    TrueName[0]:=char(i);
  end
  else IOstatus:=false;
end;

procedure GetShortName(LongName:string; var ShortName:string);
var
  regs:registers;
  NameLen:longint;
begin
  ShortName:=LongName;
  NameLen:=length(LongName)+1;
  Pas2Cstr(LongName);
  copytodos(LongName, NameLen);
  regs.ds:=tb_segment;
  regs.esi:=tb_offset;
  regs.es:=tb_segment;
  regs.edi:=tb_offset;
  if LFNSupport then begin
    regs.ax:=$7160;
    regs.cx:=1;
    regs.flags:=fcarry;
  end
  else regs.ah:=$60;
  msdos(regs);
  if (regs.flags and fcarry)=0 then begin
    copyfromdos(ShortName, 256);
    IOstatus:=true;
    C2Passtr(ShortName);
  end
  else IOstatus:=false;
end;

procedure GetLongName(ShortName:string; var LongName:string);
var
  regs:registers;
  Buffer:array [0..LFN_MAX_PATH] of char;
  i:byte;
  NameLen:longint;
begin
  LongName:=ShortName;
  NameLen:=length(ShortName)+1;
  Pas2Cstr(ShortName);
  copytodos(ShortName, NameLen);
  regs.ds:=tb_segment;
  regs.esi:=tb_offset;
  regs.es:=tb_segment;
  regs.edi:=tb_offset;
  if LFNSupport then begin
    regs.ax:=$7160;
    regs.cx:=2;
    regs.flags:=fcarry;
  end
  else regs.ah:=$60;
  msdos(regs);
  if (regs.flags and fcarry)=0 then begin
    copyfromdos(Buffer, LFN_MAX_PATH+1);
    IOstatus:=true;
    i:=0;
    while (Buffer[i]>#0) and (i<255) do begin
      LongName[i+1]:=Buffer[i];
      inc(i);
    end;
    LongName[0]:=char(i);
  end
  else IOstatus:=false;
end;

procedure CreateTempFile(Path:string; var TempFileName:string; var FileHandle:word; FileAttr:byte);
var
  regs:registers;
  PathLen:longint;
begin
  GetShortName(Path,Path);
  PathLen:=length(Path)+1;
  Pas2Cstr(Path);
  copytodos(Path, PathLen);
  regs.ah:=$5A;
  regs.cx:=word(FileAttr);
  regs.ds:=tb_segment;
  regs.edx:=tb_offset;
  msdos(regs);
  if (regs.flags and fcarry)=0 then begin
    copyfromdos(TempFileName, 256);
    IOstatus:=true;
    C2Passtr(TempFileName);
    FileHandle:=regs.ax;
  end
  else IOstatus:=false;
end;

function GetTempDir:string;
var
  TempDir:string;
begin
  TempDir:=GetEnv('TMP');
  if TempDir='' then TempDir:=GetEnv('TEMP');
  if TempDir='' then CWD(0,TempDir);
  GetTempDir:=TempDir;
end;

procedure FSplit(Path:string; var Drive:string; var Dir:string; var FileName:string; var Ext:string);
var
  i:byte;
begin
  Path:=DelSpaces(Path);
  i:=Pos('\', Path);
  if i>0 then begin
    FileName:=RightStr(Path, length(Path)-i);
    Path:=LeftStr(Path, i);
    i:=Pos('\', FileName);
    while i>0 do begin
      Path:=Path+LeftStr(FileName, i);
      FileName:=RightStr(FileName, length(FileName)-i);
      i:=Pos('\', FileName);
    end;
  end
  else begin
    i:=Pos(':',Path);
    FileName:=RightStr(Path, length(Path)-i);
    Path:=LeftStr(Path, i);
  end;
  i:=Pos(':',Path);
  Dir:=RightStr(Path, length(Path)-i);
  Drive:=Leftstr(Path, i);
  i:=Pos('.', FileName);
  if i>0 then begin
    Ext:=RightStr(FileName, length(FileName)-i+1);
    FileName:=LeftStr(FileName, i-1);
    i:=Pos('.', Ext);
    while i>1 do begin
      FileName:=FileName+LeftStr(Ext, i-1);
      Ext:=RightStr(Ext, length(Ext)-i+1);
      i:=Pos('.', Ext);
    end;
  end
  else Ext:='';
end;
end.
