{ Copyright(C) ɹ 2001-2002}
{ Programmed by Ma Bingyao }
{ Jan 30, 2002 05:50 }
Unit xstr;

{****************************} interface {*********************************}
const
  UnicodeTableMinIndex=19968;
  UnicodeTableMaxIndex=40869;

function RightChar(s:string):char;
function LeftChar(s:string):char;
function LeftStr(s:string; n:byte):string;
function RightStr(s:string; n:byte):string;
function MidStr(s:string; pos:byte; n:byte):string;
function LowCaseStr(s:string):string;
function UpCaseStr(s:string):string;
function DelChars(s:string; symb:char):string;
function DelLSpaces(s:string):string;
function DelRSpaces(s:string):string;
function DelSpaces(s:string):string;
function RepeatStr(s:string; n:byte):string;
function IntToStr(i:longint; n:byte):string;
procedure Pas2Cstr(var s:string);
procedure C2Passtr(var s:string);
function Uni2GB(Unicode:word):string;

{*************************} implementation {*******************************}

(* procedure UnicodeTable; external; {$L UNICODE.OBJ} *)
{$INCLUDE UNICODE.INC}

function LeftChar(s:string):char;
begin
  if s='' then LeftChar:=#0 else LeftChar:=s[1];
end;

function RightChar(s:string):char;
begin
  RightChar:=s[byte(s[0])];
end;

function LeftStr(s:string; n:byte):string;
begin
  s[0]:=char(n);
  Leftstr:=s;
end;

function RightStr(s:string; n:byte):string;
var
  len, i:byte;
begin
  len:=byte(s[0]);
  for i:=len-n+1 to len do s[i-(len-n)]:=s[i];
  s[0]:=char(n);
  RightStr:=s;
end;

function MidStr(s:string; pos:byte; n:byte):string;
var
  i:byte;
begin
  for i:=pos to pos+n do s[i-pos+1]:=s[i];
  s[0]:=char(n);
  MidStr:=s;
end;

function LowCaseStr(s:string):string;
var
  len, i:byte;
begin
  len:=byte(s[0]);
  for i:=1 to len do if (s[i]>='A') and (s[i]<='Z') then s[i]:=char(ord(s[i])-ord('A')+ord('a'));
  LowCaseStr:=s;
end;

function UpCaseStr(s:string):string;
var
  len, i:byte;
begin
  len:=byte(s[0]);
  for i:=1 to len do if (s[i]>='a') and (s[i]<='z') then s[i]:=char(ord(s[i])-ord('a')+ord('A'));
  UpCaseStr:=s;
end;

function DelChars(s:string; symb:char):string;
var
  len, i, j:byte;
begin
  len:=byte(s[0]);
  i:=0;
  j:=0;
  while i<len do begin
    if s[i+1]=symb then begin
      inc(i);
      inc(j);
    end
    else begin
    s[i-j+1]:=s[i+1];
    inc(i);
    end;
  end;
  s[0]:=char(len-j);
  DelChars:=s;
end;

function DelLSpaces(s:string):string;
var
  len, i:byte;
begin
  len:=byte(s[0]);
  i:=0;
  while (i<len) and (s[i+1]=' ') do inc(i);
  DelLSpaces:=MidStr(s, i+1, len-i);
end;

function DelRSpaces(s:string):string;
begin
  while RightChar(s)=' ' do s:=LeftStr(s,byte(s[0])-1);
  DelRSpaces:=s;
end;

function DelSpaces(s:string):string;
begin
  DelSpaces:=DelLSpaces(DelRSpaces(s));
end;

function RepeatStr(s:string; n:byte):string;
var
  i:byte;
  rs:string;
begin
  rs:='';
  for i:=1 to n do rs:=rs+s;
  RepeatStr:=rs;
end;

function IntToStr(i:longint; n:byte):string;
var
  s:string;
begin
  Str(i:0, s);
  if n>length(s) then s:=RepeatStr('0',n-length(s))+s;
  IntToStr:=s;
end;

procedure Pas2Cstr(var s:string);
var len,i:byte;
begin
  len:=byte(s[0]);
  for i:=1 to len do s[i-1]:=s[i];
  s[len]:=#0;
end;

procedure C2Passtr(var s:string);
var len,i:byte;
begin
  i:=0;
  while s[i]<>#0 do inc(i);
  len:=i;
  for i:=len downto 1 do s[i]:=s[i-1];
  s[0]:=char(len);
end;

function Uni2GB(Unicode:word):string;
var
  index : word;
begin
  if (Unicode>=UnicodeTableMinIndex) and (Unicode<=UnicodeTableMaxIndex) then begin
    index := (Unicode-UnicodeTableMinIndex) shl 1;
    Uni2GB:=UnicodeTable[index] + UnicodeTable[index + 1];
  end
  else Uni2GB:='';
end;

end.
