{ Copyright(C) ɹ 2001-2002}
{ Programmed by Ma Bingyao }
{ Aug 19, 2002 09:50 }
Unit img;
{****************************} interface {*********************************}

function IsDDI(FileHandle:word):boolean;
function DDI2UnCompressIMG(InputFileHandle, OutputFileHandle:word):boolean;
function IsCompressIMG(FileHandle:word):boolean;
function DeCompressIMG(InputFileHandle, OutputFileHandle:word):boolean;
function IsUnCompressIMG(FileHandle:word):boolean;
function ExtractUnCompressIMG(FileHandle:word):boolean;
procedure ListUnCompressIMG(FileHandle:word);

{*************************} implementation {*******************************}

uses crt, xstr, dos, xdos;

const
  IMGFileHeadDefaultLength=$B8;
  MAX_FDTIndex=512;
  BytesPerSector=512;
  MAX_DataBlockIndex=65534;
  IMGFileHeadLength:word=0;
  IMGFileTracks:byte=0;
  IMGFileSectors:byte=0;
  IMGFileTracksTableStartPos:word=0;

type
  BPBRec=Packed Record
    SecLen:word;
    SecPerUnit:byte;
    ReservedSec:word;
    FATNum:byte;
    DirNum:word;
    TotalSec:word;
    DiskID:byte;
    SecPerFAT:word;
    SecPerTrack:word;
    Heads:word;
    HiddenSec:Longint;
    ExTotalSec:longint;
    DriveNum:byte;
    Reserved:byte;
    Sign:byte;
    VolumeSerialNumber:longint;
    Volume:string[10];
    FileSystem:string[7];
  end;
  FDTItemRec=Packed Record
  case integer of
    0:(Name:array [1..8] of char;
       Ext:array [1..3] of char;
       Attr:byte;
       Reserved1:byte;
       CreationTimeMilliSecond:byte;
       CreationDateTime:longint;
       LastAccessDate:word;
       Reserved2:word;
       LastWriteDateTime:longint;
       StartUnitNum:word;
       Size:longint);
    1:(Number:byte;
       Name1:array [1..5] of word;
       LFNSign:byte;
       Reserved3:word;
       Name2:array [1..6] of word;
       Reserved4:word;
       Name3:array [1..2] of word);
  end;
  FDTRec=array [0..MAX_FDTIndex] of FDTItemRec;
  PFDT=^FDTRec;
  SectorRec=array [1..BytesPerSector] of byte;
  PSector=^SectorRec;
  DataBlockRec=array [0..MAX_DataBlockIndex] of byte;
  PDataBlock=^DataBlockRec;

var
  IMGFileHead:array [1..IMGFileHeadDefaultLength] of byte;
  BPB:BPBRec;
  FATSectors:PDataBlock;
  BytesPerUnit:word;
  DataStartPos:longint;

function IsDDI(FileHandle:word):boolean;
var
  FileLength:longint;
  Loc:longint;
  DataLength:word;
  IM:word;
  DiskID:byte;
  OEMName:string[20];
begin
  IsDDI:=false;
  if not IOisOK then exit;
  Loc:=0;
  LseekFile(FileHandle,Loc,SEEK_SET);
  if not IOisOK then exit;
  DataLength:=20;
  OEMName[0]:=char(DataLength);
  ReadFile(FileHandle,DataLength,OEMName[1]);
  if OEMName='MSD Image Version 1 ' then begin
    DataStartPos:=$500;
    Loc:=DataStartPos+$0B;
    LseekFile(FileHandle,Loc,SEEK_SET);
    if not IOisOK then exit;
    DataLength:=sizeof(BPB);
    ReadFile(FileHandle,DataLength,BPB);
    if (not IOisOK) then exit;
    Loc:=$43;
    LseekFile(FileHandle,Loc,SEEK_SET);
    if not IOisOK then exit;
    DataLength:=sizeof(word);
    ReadFile(FileHandle,DataLength,IM);
    if not IOisOK then exit;
    IMGFileTracks:=IM div BPB.Heads-1;
    Loc:=$4D;
    LseekFile(FileHandle,Loc,SEEK_SET);
    if not IOisOK then exit;
    DataLength:=sizeof(word);
    ReadFile(FileHandle,DataLength,IM);
    if not IOisOK then exit;
    IMGFileSectors:=IM div BPB.Heads;
  end
  else begin
    FileLength:=0;
    LseekFile(FileHandle,FileLength,SEEK_END);
    if not IOisOK then exit;
    if (FileLength mod BytesPerSector)>0 then exit;
    Loc:=0;
    LseekFile(FileHandle,Loc,SEEK_SET);
    if not IOisOK then exit;
    DataLength:=sizeof(IM);
    ReadFile(FileHandle,DataLength,IM);
    if (IM<>$4D49) or (not IOisOK) then exit;
    Loc:=$0A;
    LseekFile(FileHandle,Loc,SEEK_SET);
    if not IOisOK then exit;
    DataLength:=sizeof(DiskID);
    ReadFile(FileHandle,DataLength,DiskID);
    case DiskID of
      1: begin
           IMGFileTracks:=39;
           IMGFileSectors:=9;
         end;
      2: begin
           IMGFileTracks:=79;
           IMGFileSectors:=15;
         end;
      3: begin
           IMGFileTracks:=79;
           IMGFileSectors:=9;
         end;
      4: begin
           IMGFileTracks:=79;
           IMGFileSectors:=18;
         end;
      else exit;
    end;
    DataStartPos:=IMGFileSectors shl 9;
    Loc:=DataStartPos+$0B;
    LseekFile(FileHandle,Loc,SEEK_SET);
    if not IOisOK then exit;
    DataLength:=sizeof(BPB);
    ReadFile(FileHandle,DataLength,BPB);
    if (not IOisOK) then exit;
  end;
  if (BPB.SecLen<>BytesPerSector) then exit;
  if (BPB.SecPerTrack<>IMGFileSectors) then exit;
  if (BPB.TotalSec<>(IMGFileTracks+1)*BPB.Heads*BPB.SecPerTrack) then exit;
  IsDDI:=true;
end;

function DDI2UnCompressIMG(InputFileHandle, OutputFileHandle:word):boolean;
var
  InputLoc, OutputLoc:longint;
  FileLength:longint;
  DataSecNum:longint;
  TrackLength:word;
  DataLength:word;
  Sectors:Pointer;
  n, i:longint;
  x, y:byte;
begin
  DDI2UnCompressIMG:=false;
  if not IOisOK then exit;
  FileLength:=0;
  LseekFile(InputFileHandle,FileLength,SEEK_END);
  if not IOisOK then exit;
  DataSecNum:=(FileLength-DataStartPos) div BytesPerSector;
  n:=DataSecNum div BPB.SecPerTrack;
  TrackLength:=BytesPerSector*BPB.SecPerTrack;
  InputLoc:=DataStartPos-TrackLength;
  OutputLoc:=-TrackLength;
  GetMem(Sectors, TrackLength);
  {ΪʾϢ}
  y:=wherey;
  gotoxy(2,y);
  TextColor(lightmagenta);
  write('|--------------------------------------------------------------------------|');
  TextColor(lightgray);
  {ΪʾϢ}
  for i:=1 to n do begin
    InputLoc:=InputLoc+TrackLength;
    LseekFile(InputFileHandle,InputLoc,SEEK_SET);
    if not IOisOK then exit;
    DataLength:=TrackLength;
    ReadFile(InputFileHandle,DataLength,Sectors^);
    if not IOisOK then exit;
    OutputLoc:=OutputLoc+TrackLength;
    LseekFile(OutputFileHandle,OutputLoc,SEEK_SET);
    if not IOisOK then exit;
    DataLength:=TrackLength;
    WriteFile(OutputFileHandle,DataLength,Sectors^);
    if not IOisOK then exit;
    {ΪʾϢ}
    gotoxy(3,y);
    TextBackGround(LightGreen);
    for x:=1 to round(74*(real(i)*BPB.SecPerTrack/BPB.TotalSec)) do write(' ');
    gotoxy(38,y);
    TextBackGround(Black);
    TextColor(lightmagenta);
    write(round(100*(real(i)*BPB.SecPerTrack/BPB.TotalSec)),'%');
    TextColor(lightgray);
    {ΪʾϢ}
  end;
  FillChar(Sectors^, TrackLength, 0);
  n:=DataSecNum mod BPB.SecPerTrack;
  if n>0 then begin
    InputLoc:=InputLoc+TrackLength;
    LseekFile(InputFileHandle,InputLoc,SEEK_SET);
    if not IOisOK then exit;
    DataLength:=n*BytesPerSector;
    ReadFile(InputFileHandle,DataLength,Sectors^);
    if not IOisOK then exit;
    OutputLoc:=OutputLoc+TrackLength;
    LseekFile(OutputFileHandle,OutputLoc,SEEK_SET);
    if not IOisOK then exit;
    DataLength:=TrackLength;
    WriteFile(OutputFileHandle,DataLength,Sectors^);
    if not IOisOK then exit;
  end;
  DataSecNum:=BPB.TotalSec-DataSecNum;
  n:=DataSecNum div BPB.SecPerTrack;
  DataLength:=TrackLength;
  FillChar(Sectors^, DataLength, 0);
  for i:=n downto 1 do begin
    OutputLoc:=OutputLoc+TrackLength;
    LseekFile(OutputFileHandle,OutputLoc,SEEK_SET);
    if not IOisOK then exit;
    DataLength:=TrackLength;
    WriteFile(OutputFileHandle,DataLength,Sectors^);
    if not IOisOK then exit;
    {ΪʾϢ}
    gotoxy(3,y);
    TextBackGround(LightGreen);
    for x:=1 to round(74*(1.0-(i-1.0)*BPB.SecPerTrack/BPB.TotalSec)) do write(' ');
    gotoxy(38,y);
    TextBackGround(Black);
    TextColor(lightmagenta);
    write(round(100*(1.0-(i-1.0)*BPB.SecPerTrack/BPB.TotalSec)),'%');
    TextColor(lightgray);
    {ΪʾϢ}
  end;
  FreeMem(Sectors, TrackLength);
  {ΪʾϢ}
  DelLine;
  Gotoxy(1,y);
  {ΪʾϢ}
  DDI2UnCompressIMG:=true;
end;

function IsCompressIMG(FileHandle:word):boolean;
var
  BlockLength:word;
  BlockNumber:word;
  Loc:longint;
  DataLength:word;
  FileLength:longint;
  i:word;
begin
  if not IOisOK then begin
    IsCompressIMG:=false;
    exit;
  end;
  FileLength:=0;
  LseekFile(FileHandle,FileLength,SEEK_END);
  if not IOisOK then begin
    IsCompressIMG:=false;
    exit;
  end;
  Loc:=0;
  LseekFile(FileHandle,Loc,SEEK_SET);
  if not IOisOK then begin
    IsCompressIMG:=false;
    exit;
  end;
  DataLength:=IMGFileHeadDefaultLength;
  ReadFile(FileHandle,DataLength,IMGFileHead[1]);
  if not IOisOK then begin
    IsCompressIMG:=false;
    exit;
  end;
  if (IMGFileHead[1]=$FF) and (IMGFileHead[2]=$18) then begin
    IMGFileHeadLength:=IMGFileHeadDefaultLength;
    IMGFileTracks:=IMGFileHead[$0F];
    IMGFileSectors:=IMGFileHead[$10];
    IMGFileTracksTableStartPos:=$11;
  end
  else begin
    IMGFileHeadLength:=$A6;
    IMGFileTracks:=IMGFileHead[1];
    IMGFileSectors:=IMGFileHead[2];
    IMGFileTracksTableStartPos:=3;
  end;
  BlockNumber:=0;
  for i:=IMGFileTracksTableStartPos to IMGFileHeadLength do begin
    if IMGFileHead[i]>1 then begin
      IsCompressIMG:=false;
      exit;
    end;
    inc(BlockNumber, IMGFileHead[i]);
  end;
  Loc:=IMGFileHeadLength;
  for i:=1 to BlockNumber do begin
    LseekFile(FileHandle,Loc,SEEK_SET);
    if not IOisOK then begin
      IsCompressIMG:=false;
      exit;
    end;
    DataLength:=2;
    ReadFile(FileHandle,DataLength,BlockLength);
    if not IOisOK then begin
      IsCompressIMG:=false;
      exit;
    end;
    inc(Loc, BlockLength+2);
  end;
  if FileLength=Loc then IsCompressIMG:=true
  else IsCompressIMG:=false;
end;

function DeCompressIMG(InputFileHandle, OutputFileHandle:word):boolean;
var
  Track, DataBlock:PDataBlock;
  BlockLength:word;
  Loc:longint;
  DataLength:word;
  Tn, Hn:word;
  Index:word;
  BytesPerTrack:word;
  i, j, n:word;
  x, y:byte;
begin
  if not IOisOK then begin
    DeCompressIMG:=false;
    exit;
  end;
  BytesPerTrack:=BytesPerSector*IMGFileSectors;
  GetMem(Track,BytesPerTrack);
  Loc:=0;
  LseekFile(OutputFileHandle, Loc, SEEK_SET);
  Loc:=IMGFileHeadLength;
  LseekFile(InputFileHandle, Loc, SEEK_SET);
  {ΪʾϢ}
  y:=wherey;
  gotoxy(2,y);
  TextColor(lightmagenta);
  write('|--------------------------------------------------------------------------|');
  TextColor(lightgray);
  {ΪʾϢ}
  for Tn:=0 to IMGFileTracks do for Hn:=0 to 1 do begin
    Index:=IMGFileTracksTableStartPos+(Tn*2+Hn);
    if IMGFileHead[Index]=0 then begin
      DataLength:=BytesPerTrack;
      FillChar(Track^[0], DataLength, 0);
      WriteFile(OutputFileHandle, Datalength, Track^[0]);
    end
    else begin
      DataLength:=2;
      ReadFile(InputFileHandle, DataLength, BlockLength);
      GetMem(DataBlock,BlockLength);
      DataLength:=BlockLength;
      ReadFile(InputFileHandle, DataLength, DataBlock^[0]);
      {}
      i:=1;
      j:=0;
      while i<BlockLength do begin
        if DataBlock^[i]=DataBlock^[0] then begin
          for n:=1 to DataBlock^[i+2] do begin
            Track^[j]:=DataBlock^[i+1];
            inc(j);
          end;
          inc(i,3);
        end
        else begin
          Track^[j]:=DataBlock^[i];
          inc(j);
          inc(i);
        end;
      end;
      DataLength:=BytesPerTrack;
      WriteFile(OutputFileHandle, DataLength, Track^[0]);
      FreeMem(DataBlock,BlockLength);
    end;
    {ΪʾϢ}
    gotoxy(3,y);
    TextBackGround(LightGreen);
    for x:=1 to round(74.0*(Tn*2+Hn)/(IMGFileTracks*2)) do write(' ');
    TextBackGround(Black);
    gotoxy(38,y);
    TextColor(lightmagenta);
    write(round(100.0*(Tn*2+Hn)/(IMGFileTracks*2)),'%');
    TextColor(lightgray);
    {ΪʾϢ}
  end;
  {ΪʾϢ}
  DelLine;
  Gotoxy(1,y);
  {ΪʾϢ}
  FreeMem(Track,BytesPerTrack);
  DeCompressIMG:=true;
end;

function IsUnCompressIMG(FileHandle:word):boolean;
var
  Sector:PSector;
  Loc:longint;
  DataLength:word;
  FileLength:longint;
begin
  if not IOisOK then begin
    IsUnCompressIMG:=false;
    exit;
  end;
  FileLength:=0;
  LseekFile(FileHandle,FileLength,SEEK_END);
  if not IOisOK then begin
    IsUnCompressIMG:=false;
    exit;
  end;
  Loc:=0;
  LseekFile(FileHandle,Loc,SEEK_SET);
  if not IOisOK then begin
    IsUnCompressIMG:=false;
    exit;
  end;
  GetMem(Sector,BytesPerSector);
  DataLength:=BytesPerSector;
  ReadFile(FileHandle,DataLength,Sector^[1]);
  if not IOisOK then begin
    IsUnCompressIMG:=false;
    FreeMem(Sector,BytesPerSector);
    exit;
  end;
  move(Sector^[12], BPB, sizeof(BPB));
  FreeMem(Sector,BytesPerSector);
  if BPB.SecLen<>BytesPerSector then begin
    IsUnCompressIMG:=false;
    exit;
  end;
  if BPB.TotalSec>0 then BPB.ExTotalSec:=BPB.TotalSec;
  if BPB.ExTotalSec*BPB.SecLen<>FileLength then begin
    IsUnCompressIMG:=false;
    exit;
  end;
  IsUnCompressIMG:=true;
end;

function NextUnitNum(var CurrentUnitNum:word):word;
begin
  if odd(CurrentUnitNum) then begin
    NextUnitNum:=(word(FATSectors^[CurrentUnitNum*3 div 2])
    +(word(FATSectors^[(CurrentUnitNum*3 div 2)+1]) shl 8)) shr 4;
  end
  else begin
    NextUnitNum:=((word(FATSectors^[(CurrentUnitNum*3 div 2)+1]) shl 8)
    +word(FATSectors^[CurrentUnitNum*3 div 2])) and $FFF;
  end;
end;

function GetLocation(CurrentUnitNum:word):longint;
begin
  GetLocation:=DataStartPos+longint(CurrentUnitNum-2)*longint(BytesPerUnit);
end;

procedure ExtractFiles(var DirTreeRoot:PDirTreeNode; FDT:PFDT;
FDTIndex:word; FileHandle:word);
var
  UnitSectors:PDataBlock;
  CurUnitNum:word;
  NewFileHandle:word;
  Loc:longint;
  DataLength:word;
  SubFDT:PFDT;
  SubFDTLength:word;
  i, j:byte;
  CurrentPath:string;
  n:longint;
begin
  while (FDT^[FDTIndex].Name[1]='.') do inc(FDTIndex);
  New(DirTreeRoot);
  while (FDT^[FDTIndex].Name[1]<>#0) do begin
    while (FDT^[FDTIndex].LFNSign=$0F) and ((FDT^[FDTIndex].Name[1]<'A')
    or (FDT^[FDTIndex].Name[1]>'T')) do inc(FDTIndex);
    if (FDT^[FDTIndex].LFNSign=$0F) and LFNSupport then begin
      i:=FDT^[FDTIndex].Number-ord('A')+1;
      inc(FDTIndex, i);
      DirTreeRoot^.Name:='';
      while i>0 do with FDT^[FDTIndex-1] do begin
        for j:=1 to 5 do begin
          if (Name1[j]>0) and (Name1[j]<256) then
            DirTreeRoot^.Name:=DirTreeRoot^.Name+char(Name1[j])
          else if (Name1[j]>=UnicodeTableMinIndex) and (Name1[j]<=UnicodeTableMaxIndex) then begin
            DirTreeRoot^.Name:=DirTreeRoot^.Name+Uni2GB(Name1[j]);
          end;
        end;
        for j:=1 to 6 do begin
          if (Name2[j]>0) and (Name2[j]<256) then
            DirTreeRoot^.Name:=DirTreeRoot^.Name+char(Name2[j])
          else if (Name2[j]>=UnicodeTableMinIndex) and (Name2[j]<=UnicodeTableMaxIndex) then begin
            DirTreeRoot^.Name:=DirTreeRoot^.Name+Uni2GB(Name2[j]);
          end;
        end;
        for j:=1 to 2 do begin
          if (Name3[j]>0) and (Name3[j]<256) then
            DirTreeRoot^.Name:=DirTreeRoot^.Name+char(Name3[j])
          else if (Name3[j]>=UnicodeTableMinIndex) and (Name3[j]<=UnicodeTableMaxIndex) then begin
            DirTreeRoot^.Name:=DirTreeRoot^.Name+Uni2GB(Name3[j]);
          end;
        end;
        dec(i);
        dec(FDTIndex);
      end;
      inc(FDTIndex, FDT^[FDTIndex].Number-ord('A')+1);
    end
    else begin
      if (FDT^[FDTIndex].LFNSign=$0F) then begin
        inc(FDTIndex, FDT^[FDTIndex].Number-ord('A')+1);
      end;
      n:=1;
     with FDT^[FDTIndex] do begin
        for i:=1 to 8 do if (Name[i]>' ') then begin
          DirTreeRoot^.Name[n]:=Name[i];
          inc(n);
        end;
        DirTreeRoot^.Name[n]:='.';
        inc(n);
        for i:=1 to 3 do if (Ext[i]>' ') then begin
          DirTreeRoot^.Name[n]:=Ext[i];
          inc(n);
        end;
        dec(n);
        if DirTreeRoot^.Name[n]='.' then dec(n);
        DirTreeRoot^.Name[0]:=char(n);
      end;
    end;
    if LFNSupport then begin
      DirTreeRoot^.CreationTimeMilliSecond:=FDT^[FDTIndex].CreationTimeMilliSecond;
      DirTreeRoot^.CreationTime:=FDT^[FDTIndex].CreationDateTime;
      DirTreeRoot^.LastAccessTime:=longint(FDT^[FDTIndex].LastAccessDate) shl 16;
    end;
    DirTreeRoot^.Attr:=word(FDT^[FDTIndex].Attr);
    DirTreeRoot^.LastWriteTime:=FDT^[FDTIndex].LastWriteDateTime;
    DirTreeRoot^.StartUnitNum:=FDT^[FDTIndex].StartUnitNum;
    DirTreeRoot^.Size:=FDT^[FDTIndex].Size;
    with DirTreeRoot^ do begin
      if ((Attr and volumeid)=0) and (Name[1]<>char($E5)) then begin
        if (Attr and directory)>0 then begin
          CWD(0, CurrentPath);
          if CurrentPath='' then CurrentPath:=' +'+GetDefaultDrive+':\'+Name
          else CurrentPath:=' +'+GetDefaultDrive+':\'+CurrentPath+'\'+Name;
          TextColor(lightgreen);
          if (Attr and readonly)>0 then TextColor(yellow);
          if (Attr and hidden)>0 then TextColor(lightcyan);
          if (Attr and sysfile)>0 then TextColor(lightred);
          writeln(CurrentPath);
          MD(Name);
          SetFileAttr(Name, Attr and not(directory));
          CD(Name);
          CurUnitNum:=StartUnitNum;
          SubFDTLength:=BytesPerUnit+32;
          GetMem(SubFDT, SubFDTLength);
          while (CurUnitNum<$FF0) and (CurUnitNum>$001) do begin
            FillChar(SubFDT^[0], SubFDTLength, 0);
            Loc:=GetLocation(CurUnitNum);
            LseekFile(FileHandle, Loc, SEEK_SET);
            DataLength:=BytesPerUnit;
            ReadFile(FileHandle, DataLength, SubFDT^);
            ExtractFiles(Child, SubFDT, 0, FileHandle);
            CurUnitNum:=NextUnitNum(CurUnitNum);
          end;
          CD('..');
          FreeMem(SubFDT, SubFDTLength);
        end
        else begin
          CurUnitNum:=StartUnitNum;
          CWD(0, CurrentPath);
          if CurrentPath='' then CurrentPath:=GetDefaultDrive+':\'+Name
          else CurrentPath:=GetDefaultDrive+':\'+CurrentPath+'\'+Name;
          CreateFile(CurrentPath, NewFileHandle, WRITE_ONLY, archive);
          if IOisOK then begin
            {ΪʾϢ}
            write('  ');
            TextColor(lightgreen);
            if (Attr and readonly)>0 then TextColor(yellow);
            if (Attr and hidden)>0 then TextColor(lightcyan);
            if (Attr and sysfile)>0 then TextColor(lightred);
            writeln(CurrentPath);
            i:=wherey;
            gotoxy(2,i);
            TextColor(lightmagenta);
            write('|--------------------------------------------------------------------------|');
            TextColor(lightgray);
            n:=0;
            {ΪʾϢ}
            GetMem(UnitSectors, BytesPerUnit);
            while (CurUnitNum<$FF0) and (CurUnitNum>$001) and (n<Size) do begin
              Loc:=GetLocation(CurUnitNum);
              CurUnitNum:=NextUnitNum(CurUnitNum);
              if (CurUnitNum>$FEF) or (CurUnitNum<$002) or (Size-n<BytesPerUnit) then begin
                DataLength:=(Size mod BytesPerUnit);
                if DataLength=0 then DataLength:=BytesPerUnit;
              end
              else DataLength:=BytesPerUnit;
              LseekFile(FileHandle, Loc, SEEK_SET);
              ReadFile(FileHandle, DataLength, UnitSectors^[0]);
              WriteFile(NewFileHandle, DataLength, UnitSectors^[0]);
              {ΪʾϢ}
              inc(n,DataLength);
              gotoxy(3,i);
              if Size>n then begin
                TextBackGround(LightGreen);
                for j:=1 to round(74*(real(n)/Size)) do write(' ');
                TextBackGround(Black);
                gotoxy(38,i);
                TextColor(lightmagenta);
                write(round(100*(real(n)/Size)),'%');
                TextColor(lightgray);
              end
              else begin
                TextBackGround(LightGreen);
                for j:=1 to 74 do write(' ');
                TextBackGround(Black);
                gotoxy(38,i);
                TextColor(lightmagenta);
                write('100%');
                TextColor(lightgray);
              end;
              {ΪʾϢ}
            end;
            FreeMem(UnitSectors, BytesPerUnit);
            SetFileCreationTime(NewFileHandle, CreationTime, CreationTimeMilliSecond);
            SetFileLastAccessTime(NewFileHandle, LastAccessTime);
            SetFileLastWriteTime(NewFileHandle, LastWriteTime);
            CloseFile(NewFileHandle);
            SetFileAttr(Name, Attr);
            {ΪʾϢ}
            DelLine;
            Gotoxy(1,i);
            {ΪʾϢ}
          end
          else begin
            {ΪʾϢ}
            write('  ');
            TextColor(lightred);
            writeln('Can''t create file ' + CurrentPath);
            TextColor(lightgray);
            {ΪʾϢ}
            DeleteFile(Name);
          end;
          DirTreeRoot^.Child:=NIL;
        end;
      end;
    end;
    inc(FDTIndex);
  end;
  dispose(DirTreeRoot);
  DirTreeRoot:=NIL;
end;

function ExtractUnCompressIMG(FileHandle:word):boolean;
var
  DirTreeRoot:PDirTreeNode;
  RootFDT:PFDT;
  FATStartPos:longint;
  BytesPerFAT:word;
  RootStartPos:longint;
  RootLength:word;
  DataLength:word;
  Loc:longint;
begin
  if not IOisOK then begin
    ExtractUnCompressIMG:=false;
    exit;
  end;
  FATStartPos:=BPB.ReservedSec*BPB.SecLen;
  BytesPerFAT:=BPB.SecPerFAT*BPB.SecLen;
  RootStartPos:=BPB.FATNum*BytesPerFAT + FATStartPos;
  RootLength:=word(BPB.DirNum) shl 5;
  DataStartPos:=RootLength + RootStartPos;
  BytesPerUnit:=BPB.SecPerUnit*BPB.SecLen;
  GetMem(FATSectors, BytesPerFAT);
  GetMem(RootFDT, RootLength+32);
  FillChar(RootFDT^[BPB.DirNum], 32, 0);
  Loc:=FATStartPos;
  DataLength:=BytesPerFAT;
  LseekFile(FileHandle, Loc, SEEK_SET);
  ReadFile(FileHandle, DataLength, FATSectors^[0]);
  Loc:=RootStartPos;
  DataLength:=RootLength;
  LseekFile(FileHandle, Loc, SEEK_SET);
  ReadFile(FileHandle, DataLength, RootFDT^[0]);
  ExtractFiles(DirTreeRoot, RootFDT, 0, FileHandle);
  FreeMem(FATSectors, BytesPerFAT);
  FreeMem(RootFDT, RootLength+32);
  ExtractUnCompressIMG:=true;
end;

procedure ListFiles(var DirTreeRoot:PDirTreeNode; FDT:PFDT;
FDTIndex:word; FileHandle:word);
var
  CurUnitNum:word;
  Loc:longint;
  DataLength:word;
  SubFDT:PFDT;
  SubFDTLength:word;
  i, j:byte;
  n:longint;
  CurrentPath, Attrib:string;
  Time:DateTime;
  TmpDirNode:PDirTreeNode;
begin
  while (FDT^[FDTIndex].Name[1]='.') do inc(FDTIndex);
  TmpDirNode:=DirTreeRoot;
  New(DirTreeRoot);
  DirTreeRoot^.Brother:=TmpDirNode;
  while (FDT^[FDTIndex].Name[1]<>#0) do begin
    while (FDT^[FDTIndex].LFNSign=$0F) and ((FDT^[FDTIndex].Name[1]<'A')
    or (FDT^[FDTIndex].Name[1]>'T')) do inc(FDTIndex);
    if (FDT^[FDTIndex].LFNSign=$0F) and LFNSupport then begin
      i:=FDT^[FDTIndex].Number-ord('A')+1;
      inc(FDTIndex, i);
      DirTreeRoot^.Name:='';
      while i>0 do with FDT^[FDTIndex-1] do begin
        for j:=1 to 5 do begin
          if (Name1[j]>0) and (Name1[j]<256) then
            DirTreeRoot^.Name:=DirTreeRoot^.Name+char(Name1[j])
          else if (Name1[j]>=UnicodeTableMinIndex) and (Name1[j]<=UnicodeTableMaxIndex) then begin
            DirTreeRoot^.Name:=DirTreeRoot^.Name+Uni2GB(Name1[j]);
          end;
        end;
        for j:=1 to 6 do begin
          if (Name2[j]>0) and (Name2[j]<256) then
            DirTreeRoot^.Name:=DirTreeRoot^.Name+char(Name2[j])
          else if (Name2[j]>=UnicodeTableMinIndex) and (Name2[j]<=UnicodeTableMaxIndex) then begin
            DirTreeRoot^.Name:=DirTreeRoot^.Name+Uni2GB(Name2[j]);
          end;
        end;
        for j:=1 to 2 do begin
          if (Name3[j]>0) and (Name3[j]<256) then
            DirTreeRoot^.Name:=DirTreeRoot^.Name+char(Name3[j])
          else if (Name3[j]>=UnicodeTableMinIndex) and (Name3[j]<=UnicodeTableMaxIndex) then begin
            DirTreeRoot^.Name:=DirTreeRoot^.Name+Uni2GB(Name3[j]);
          end;
        end;
        dec(i);
        dec(FDTIndex);
      end;
      inc(FDTIndex, FDT^[FDTIndex].Number-ord('A')+1);
    end
    else begin
      if (FDT^[FDTIndex].LFNSign=$0F) then begin
        inc(FDTIndex, FDT^[FDTIndex].Number-ord('A')+1);
      end;
      n:=1;
     with FDT^[FDTIndex] do begin
        for i:=1 to 8 do if (Name[i]>' ') then begin
          DirTreeRoot^.Name[n]:=Name[i];
          inc(n);
        end;
        DirTreeRoot^.Name[n]:='.';
        inc(n);
        for i:=1 to 3 do if (Ext[i]>' ') then begin
          DirTreeRoot^.Name[n]:=Ext[i];
          inc(n);
        end;
        dec(n);
        if DirTreeRoot^.Name[n]='.' then dec(n);
        DirTreeRoot^.Name[0]:=char(n);
      end;
    end;
    if LFNSupport then begin
      DirTreeRoot^.CreationTimeMilliSecond:=FDT^[FDTIndex].CreationTimeMilliSecond;
      DirTreeRoot^.CreationTime:=FDT^[FDTIndex].CreationDateTime;
      DirTreeRoot^.LastAccessTime:=longint(FDT^[FDTIndex].LastAccessDate) shl 16;
    end;
    DirTreeRoot^.Attr:=word(FDT^[FDTIndex].Attr);
    DirTreeRoot^.LastWriteTime:=FDT^[FDTIndex].LastWriteDateTime;
    DirTreeRoot^.StartUnitNum:=FDT^[FDTIndex].StartUnitNum;
    DirTreeRoot^.Size:=FDT^[FDTIndex].Size;
    with DirTreeRoot^ do begin
      if ((Attr and volumeid)=0) and (Name[1]<>char($E5)) then begin
        write('  ');
        TmpDirNode:=DirTreeRoot;
        CurrentPath:='';
        while TmpDirNode<>NIL do begin
          CurrentPath:=TmpDirNode^.Name+'\'+CurrentPath;
          TmpDirNode:=TmpDirNode^.Brother;
        end;
        CurrentPath[0]:=char(byte(CurrentPath[0])-1);
        Attrib:='';
        TextColor(lightgreen);
        if (Attr and archive)>0 then Attrib:=Attrib+'A'
        else Attrib:=Attrib+' ';
        if (Attr and readonly)>0 then begin
          TextColor(yellow);
          Attrib:=Attrib+'R';
        end
        else Attrib:=Attrib+' ';
        if (Attr and hidden)>0 then begin
          TextColor(lightcyan);
          Attrib:=Attrib+'H';
        end
        else Attrib:=Attrib+' ';
        if (Attr and sysfile)>0 then begin
          TextColor(lightred);
          Attrib:=Attrib+'S';
        end
        else Attrib:=Attrib+' ';
        UnPackTime(LastWriteTime, Time);
        write(Attrib:8);
        if (Attr and directory)>0 then write('    <DIR>    ')
        else write(Size:9,'    ');
        i:=wherex;
        j:=wherey;
        gotoxy(i,j);
        write(IntToStr(Time.month, 2), '-', IntToStr(Time.day, 2), '-', IntToStr(Time.year, 4), ' ');
        write(IntToStr(Time.hour, 2), ':', IntToStr(Time.min, 2), ':', IntToStr(Time.sec, 2), '   ');
        writeln(CurrentPath);
        if j=hi(windmax)+1 then begin
          TextColor(lightgray);
          write('Press any key to continue ...');
          j:=byte(readkey);
          clrscr;
          writeln;
        end;
        if (Attr and directory)>0 then begin
          CurUnitNum:=StartUnitNum;
          SubFDTLength:=BytesPerUnit+32;
          GetMem(SubFDT, SubFDTLength);
          while (CurUnitNum<$FF0) and (CurUnitNum>$001) do begin
            FillChar(SubFDT^[0], SubFDTLength, 0);
            Loc:=GetLocation(CurUnitNum);
            LseekFile(FileHandle, Loc, SEEK_SET);
            DataLength:=BytesPerUnit;
            ReadFile(FileHandle, DataLength, SubFDT^);
            Child:=DirTreeRoot;
            ListFiles(Child, SubFDT, 0, FileHandle);
            CurUnitNum:=NextUnitNum(CurUnitNum);
          end;
          FreeMem(SubFDT, SubFDTLength);
        end;
      end;
    end;
    inc(FDTIndex);
  end;
  dispose(DirTreeRoot);
  DirTreeRoot:=NIL;
end;

procedure ListUnCompressIMG(FileHandle:word);
var
  DirTreeRoot:PDirTreeNode;
  RootFDT:PFDT;
  FATStartPos:longint;
  BytesPerFAT:word;
  RootStartPos:longint;
  RootLength:word;
  DataLength:word;
  Loc:longint;
begin
  if not IOisOK then exit;
  FATStartPos:=BPB.ReservedSec*BPB.SecLen;
  BytesPerFAT:=BPB.SecPerFAT*BPB.SecLen;
  RootStartPos:=BPB.FATNum*BytesPerFAT + FATStartPos;
  RootLength:=word(BPB.DirNum) shl 5;
  DataStartPos:=RootLength + RootStartPos;
  BytesPerUnit:=BPB.SecPerUnit*BPB.SecLen;
  GetMem(FATSectors, BytesPerFAT);
  GetMem(RootFDT, RootLength+32);
  FillChar(RootFDT^[BPB.DirNum], 32, 0);
  Loc:=FATStartPos;
  DataLength:=BytesPerFAT;
  LseekFile(FileHandle, Loc, SEEK_SET);
  ReadFile(FileHandle, DataLength, FATSectors^[0]);
  Loc:=RootStartPos;
  DataLength:=RootLength;
  LseekFile(FileHandle, Loc, SEEK_SET);
  ReadFile(FileHandle, DataLength, RootFDT^[0]);
  DirTreeRoot:=NIL;
  ListFiles(DirTreeRoot, RootFDT, 0, FileHandle);
  FreeMem(FATSectors, BytesPerFAT);
  FreeMem(RootFDT, RootLength+32);
end;

end.
